"use strict";
var assert = require("assert");
var main_1 = require("./../../../main");
var code = "enum MyEnum {}";
describe("DocumentationedDefinition write tests", function () {
    var file = main_1.getInfoFromString(code);
    describe("#write()", function () {
        it("should contain the definition written out with documentation comment when providing a properly formatted one", function () {
            var expected = "/**\n * Some description\n */\nenum MyEnum {\n}\n";
            file.enums[0].documentationComment = "/**\n * Some description\n */";
            assert.equal(file.enums[0].write(), expected);
        });
        it("should contain the definition written out with documentation comment when not providing a properly formatted one", function () {
            var expected = "/**\n * Some description\n * Over multiple lines\n * And more lines\n */\nenum MyEnum {\n}\n";
            file.enums[0].documentationComment = "Some description\nOver multiple lines\r\nAnd more lines";
            assert.equal(file.enums[0].write(), expected);
        });
    });
});

//# sourceMappingURL=jsDocedDefinitionWriteTests.js.map
