"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("function type tests", function () {
    var code = "\nlet func: <T extends string>(str: T, num?: number) => void;\nlet func2: string | (() => void);\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        variables: [{
                name: "func",
                type: {
                    text: "<T extends string>(str: T, num?: number) => void",
                    callSignatures: [{
                            minArgumentCount: 1,
                            typeParameters: [{
                                    name: "T",
                                    constraintType: { text: "string" }
                                }],
                            parameters: [{
                                    name: "str",
                                    type: { text: "T" }
                                }, {
                                    name: "num",
                                    type: { text: "number" },
                                    isOptional: true
                                }]
                        }],
                    node: {
                        text: "<T extends string>(str: T, num?: number) => void",
                        parameters: [{
                                name: "str",
                                type: { text: "T" }
                            }, {
                                name: "num",
                                type: { text: "number" },
                                isOptional: true
                            }],
                        typeParameters: [{
                                name: "T",
                                constraintType: { text: "string" }
                            }]
                    }
                }
            }, {
                name: "func2",
                type: {
                    text: "string | (() => void)",
                    unionTypes: [{
                            text: "string"
                        }, {
                            text: "() => void"
                        }]
                }
            }]
    });
});

//# sourceMappingURL=functionTypeTests.js.map
