"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("function overload signature tests", function () {
    var code = "\n/**\n * Some description overload 1\n */\nfunction myFunction<T>(num: number, t: T): number;\n/**\n * Some description overload 2\n */\nfunction myFunction<T>(str: string, t: T): string;\n/**\n * Some description\n */\nfunction myFunction<T>(myStringOrNumber: string | number, t: T): string {\n    return \"str\";\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        functions: [{
                name: "myFunction",
                documentationComment: "/**\n * Some description\n */",
                overloadSignatures: [{
                        parameters: [{
                                name: "num",
                                type: { text: "number" }
                            }, {
                                name: "t",
                                type: { text: "T" }
                            }],
                        typeParameters: [{
                                name: "T"
                            }],
                        returnType: { text: "number" },
                        minArgumentCount: 2,
                        documentationComment: "/**\n * Some description overload 1\n */"
                    }, {
                        parameters: [{
                                name: "str",
                                type: { text: "string" }
                            }, {
                                name: "t",
                                type: { text: "T" }
                            }],
                        typeParameters: [{
                                name: "T"
                            }],
                        returnType: { text: "string" },
                        minArgumentCount: 2,
                        documentationComment: "/**\n * Some description overload 2\n */"
                    }],
                parameters: [{
                        name: "myStringOrNumber",
                        type: {
                            text: "string | number",
                            unionTypes: [{
                                    text: "string"
                                }, {
                                    text: "number"
                                }]
                        }
                    }, {
                        name: "t",
                        type: { text: "T" }
                    }],
                typeParameters: [{
                        name: "T"
                    }],
                returnType: { text: "string" }
            }]
    });
});

//# sourceMappingURL=overloadSignatureTests.js.map
